function animateSolution(history, SITE, NUM_BUILDINGS)

    numIterations = floor(size(history,1)/NUM_BUILDINGS);
    footprintCorners = zeros(NUM_BUILDINGS, 4*numIterations, 2);
    openZonesWidthCorners = zeros(NUM_BUILDINGS, 4*numIterations, 2);
    openZonesLengthCorners = zeros(NUM_BUILDINGS, 4*numIterations, 2);

    for i=1:numIterations
         for b=1:NUM_BUILDINGS
            h = (i-1)*NUM_BUILDINGS + b;
            from = 4*(i-1) + 1;
            to = 4*i;
            footprintCorners(b,from:to,:) = variableToCorners(history(h,:), false, false); 
            openZonesWidthCorners(b,from:to,:) = variableToCorners(history(h,:), true, false); 
            openZonesLengthCorners(b,from:to,:) = variableToCorners(history(h,:), false, true); 
         end
    end
    
    colors =  ['r'; 'g'; 'b'; 'y'; 'm'; 'c'; 'r'; 'g'; 'b'; 'y'; 'm'; 'c'; 'r'; 'g'; 'b'; 'y'; 'm'; 'c'; 'r'; 'g'; 'b'; 'y'; 'm'; 'c'];
    figure(2);
    xlim([min(SITE(:,1)), max(SITE(:,1))]);
    ylim([min(SITE(:,2)), max(SITE(:,2))]);
    patch('Faces', 1:length(SITE), 'Vertices',SITE,'EdgeColor','black','FaceColor','none','LineWidth',1);

    footprintPatches = zeros(NUM_BUILDINGS,1);
    openZonesWidthPatches = zeros(NUM_BUILDINGS,1);
    openZonesLengthPatches = zeros(NUM_BUILDINGS,1);
    for b=1:NUM_BUILDINGS
        footprintPatches(b) = patch(transpose(footprintCorners(b,1:4,1)), transpose(footprintCorners(b,1:4,2)), colors(b));
        %openZonesWidthPatches(b) = patch('Faces', 1:length(openZonesWidthCorners(b,1:4,1)), 'Vertices', openZonesWidthCorners(b,1:4,:),'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8], 'FaceAlpha', 0.5); 
        openZonesWidthPatches(b) = patch('Faces', 1:length(openZonesWidthCorners(b,1:4,1)), 'XData', transpose(openZonesWidthCorners(b,1:4,1)),'YData', transpose(openZonesWidthCorners(b,1:4,2)),'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8], 'FaceAlpha', 0.5); 
        %openZonesLengthPatches(b) = patch('Faces', 1:length(openZonesLengthCorners(b,1:4,1)), 'Vertices', openZonesLengthCorners(b,1:4,:),'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8], 'FaceAlpha', 0.5);
        openZonesLengthPatches(b) = patch('Faces', 1:length(openZonesLengthCorners(b,1:4,1)), 'XData', transpose(openZonesLengthCorners(b,1:4,1)),'YData', transpose(openZonesLengthCorners(b,1:4,2)),'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8], 'FaceAlpha', 0.5);
    end
    for i=1:numIterations
        for b=1:NUM_BUILDINGS
            from = 4*(i-1) + 1;
            to = 4*i;
            set(footprintPatches(b), 'XData', transpose(footprintCorners(b,from:to,1)));
            set(footprintPatches(b), 'YData', transpose(footprintCorners(b,from:to,2)));
            set(openZonesWidthPatches(b), 'XData', transpose(openZonesWidthCorners(b,from:to,1)));
            set(openZonesWidthPatches(b), 'YData', transpose(openZonesWidthCorners(b,from:to,2)));
            set(openZonesLengthPatches(b), 'XData', transpose(openZonesLengthCorners(b,from:to,1)));
            set(openZonesLengthPatches(b), 'YData', transpose(openZonesLengthCorners(b,from:to,2)));
        end
        drawnow;
        pause(0.04)
    end
    
    
    
    alpha(0.7);
end