function distance=buildingOverlap(rect1Corners, rect2Corners)
    axes = getAxes(rect1Corners, rect2Corners);
    % There will always be four axes for two rectangles
    axisDistances = [0 0 0 0];
    for i=1:length(axes)
        scalars = zeros(4,2);
        for j=1:length(rect1Corners)
            p1 = rect1Corners(j,:);
            p2 = rect2Corners(j,:);
            scalars(j,1) = dot(axes(i,:), p1);
            scalars(j,2) = dot(axes(i,:), p2); 
        end
        smallest = min(scalars);
        largest = max(scalars);
        if (largest(2) >= largest(1))
            d = smallest(2) - largest(1);
        else
            d = smallest(1) - largest(2);
        end
        axisDistances(i)=d; 
    end
    elemPos = axisDistances > 0; % Logical index
    posD = axisDistances(elemPos);
    negD = axisDistances(~elemPos);
    if (not(isempty(posD)))
        minDistance=min(posD);
    else
        minDistance=max(negD);
    end
    distance=minDistance;
end

function axes=getAxes(rect1Corners, rect2Corners)
    axis11 = (rect1Corners(2,:) - rect1Corners(1,:)) / distanceBetweenPoints(rect1Corners(2,:), rect1Corners(1,:));
    axis12 = (rect1Corners(4,:) - rect1Corners(1,:)) / distanceBetweenPoints(rect1Corners(4,:), rect1Corners(1,:));
    axis21 = (rect2Corners(2,:) - rect2Corners(1,:)) / distanceBetweenPoints(rect2Corners(2,:), rect2Corners(1,:));
    axis22 = (rect2Corners(4,:) - rect2Corners(1,:)) / distanceBetweenPoints(rect2Corners(4,:), rect2Corners(1,:));
    axes=[axis11; axis12; axis21; axis22];
end
    
function dist=distanceBetweenPoints(c1, c2)
    dist=sqrt((c2(1)-c1(1))^2 + (c2(2)-c1(2))^2);
end

