function distance=buildingSiteObjectOverlap(buildingCorners,objectCorners)
    [halfBuilding1, halfBuilding2]=getHalfBuildings(buildingCorners);
    objectAxes=getSiteObjectAxes(objectCorners);
    halfBuilding1Distance = halfBuildingObjectOverlap(halfBuilding1, objectCorners, objectAxes);
    halfBuilding2Distance = halfBuildingObjectOverlap(halfBuilding2, objectCorners, objectAxes);
    if halfBuilding1Distance <= 0 && halfBuilding2Distance <= 0
        distance = max(halfBuilding1Distance, halfBuilding2Distance);
    else
        distance = min(halfBuilding1Distance, halfBuilding2Distance);
    end
end


function distance=halfBuildingObjectOverlap(halfBuildingCorners, objectCorners, objectAxes)
    halfBuildingAxes = getHalfBuildingAxes(halfBuildingCorners);
    axes = [objectAxes; halfBuildingAxes];
    numAxes = size(axes,1);
    axisDistances = zeros(1,numAxes);
    for i=1:numAxes
        halfBuildingScalars = zeros(size(halfBuildingCorners,1),1);
        objectScalars = zeros(size(objectCorners,1),1);
        for j=1:length(halfBuildingScalars)
            p = halfBuildingCorners(j,:);
            halfBuildingScalars(j) = dot(axes(i,:), p); 
        end
        for j=1:length(objectScalars)
            p = objectCorners(j,:);
            objectScalars(j) = dot(axes(i,:), p); 
        end
        largestObjectScalar = max(objectScalars);
        smallestObjectScalar = min(objectScalars);
        largestHalfBuildingScalar = max(halfBuildingScalars);
        smallestHalfBuildingScalar = min(halfBuildingScalars);
        if (largestObjectScalar >= largestHalfBuildingScalar)
            d = smallestHalfBuildingScalar - largestObjectScalar;
        else
            d = smallestObjectScalar - largestHalfBuildingScalar;
        end
        axisDistances(i)=d; 
    end
    elemPos = axisDistances > 0; % Logical index
    posD = axisDistances(elemPos);
    negD = axisDistances(~elemPos);
    if (not(isempty(posD)))
        minDistance=min(posD);
    else
        minDistance=max(negD);
    end
    distance=minDistance;
end

function axes=getSiteObjectAxes(objectCorners)
    numAxes=size(objectCorners,1);
    axes=zeros(numAxes,2);
    for i=1:numAxes
        j = mod(i,numAxes)+1;
        axes(i,:) = objectCorners(j,:)-objectCorners(i,:);
    end
end
