function [c, ceq] = confun(x, CONVEX_STATIC_OBJECTS, SITE_INEQUALITIES, SHOULD_TRANSFORM_VARIABLES)
    %cons = zeros(2*size(B,1)*(size(B,1)-1) + size(B, 1), 1);
    %if SHOULD_TRANSFORM_VARIABLES == Configuration.LINEWIDTH
    %    B = transformVariables(x, 'from');
    %else
    B = x;
    %end
    cons = zeros(2*size(B,1)*(size(B,1)-1), 1);

    k = 1;
    numVars = size(B,1);
    footprintCorners = variablesToCorners(B,SHOULD_TRANSFORM_VARIABLES);
    % No internal overlap constraint
    for i=1:numVars
        %Corners=footprintCorners((5*(i-1) + 1):(5*(i-1) + 4),:);
        iWidthExtendedCorners = altCornerPoints(B(i,:), SHOULD_TRANSFORM_VARIABLES,true, false);
        %iLengthExtendedCorners = altCornerPoints(B(i,:), SHOULD_TRANSFORM_VARIABLES,false, true);
        for j=1:numVars
            if i~=j
                jCorners = footprintCorners((6*(j-1) + 1):(6*(j-1) + 6),:);
                cons(k:k+3) = -1*nonConvexBuildingOverlap(iWidthExtendedCorners,jCorners);
                %cons(k + 1) = -1*nonCongavexBuildingOverlap(iLengthExtendedCorners,jCorners);               
                %k = k + 2;
                k = k + 4;
            end
        end
    end
    
    
    % NEW Length buffer zone
    for i=1:numVars
        iCorners=footprintCorners((6*(i-1) + 1):(6*(i-1) + 6),:);
        for j=1:numVars
            if i~=j
                jCorners = footprintCorners((6*(j-1) + 1):(6*(j-1) + 6),:);
                lcons=lengthOpenZoneOverlap(iCorners,jCorners);
                cons(k:(k+length(lcons)-1),1)=lcons;
                k = k + length(lcons);
            end
        end
    end
    
    
    % No overlap outside site constraint (linear in corner points)
    for i=1:numVars
        iCorners=footprintCorners((6*(i-1) + 1):(6*(i-1) + 6),:);
        % Add for all cornerpoints
        for j=1:size(iCorners,1)
            for m=1:size(SITE_INEQUALITIES,1)
                cons(k) = -( SITE_INEQUALITIES(m,1:2)*transpose(iCorners(j,:)) + SITE_INEQUALITIES(m,3) );
                k = k + 1;
            end
        end
    end
    
    
    % Nonconvex containment (no overlap with static objects)
    for c=1:length(CONVEX_STATIC_OBJECTS)
       for i=1:numVars
           buildingCorners = footprintCorners((6*(i-1) + 1):(6*(i-1) + 6),:);
           % One distance for each halfbuilding
           cons(k:k+1) = -1*siteOverlapNonConvex(buildingCorners,CONVEX_STATIC_OBJECTS{c});
           k = k + 2;
       end
    end
    
    
    %%}
    
    % If variables are transformed to line-and-width (LINEWIDHT)
    % (SHOULD_TRANSFORM_VARIABLES=True), then we must add a constraint for
    % the length of the building as this is not part of the bounds
    % and the kink height
    if SHOULD_TRANSFORM_VARIABLES == Configuration.LINEWIDTH
        for i=1:numVars
            x1 = B(i,1);
            y1 = B(i,2);
            x2 = B(i,3);
            y2 = B(i,4);
            w = B(i,5);
            kb = B(i,6);
            hb = abs(B(i,7));
            l = sqrt((x2-x1)^2 + (y2-y1)^2); %Length between the two given points
            beta = atan(hb/kb); %Angle of p1 corner point
            alpha = atan(hb/(1-kb)); %Angle of p2 corner point
            r = pi - beta - alpha; %Kink angle
            L = l*(sqrt(hb^2+kb^2)+sqrt(hb^2+(1-kb)^2)) - w/tan(r/2);
            cons(k)=L-Configuration.MAX_LENGTH;
            cons(k+1)=Configuration.MIN_LENGTH-L;
            
             % Kink location
            cons(k+2) = Configuration.MIN_KINK - l*sqrt(hb^2+kb^2) + 0.5*w/tan(r/2);
            cons(k+3) = Configuration.MIN_KINK - l*sqrt(hb^2+(1-kb)^2) + 0.5*w/tan(r/2);
            %cons(k+2) = Configuration.MIN_KINK - kb*l;
            %cons(k+3) = kb*l - l + Configuration.MIN_KINK;
            
            % Max kink height

            cons(k+4)=hb^2-(1/4-(kb-1/2)^2);
            cons(k+5)=-hb^2-(1/4-(kb-1/2)^2);

            
            k = k + 6;
        end
    end
    
    
        % and the kink height
    if SHOULD_TRANSFORM_VARIABLES == Configuration.LOWERLINEWIDTH
        for i=1:numVars
            x1 = B(i,1);
            y1 = B(i,2);
            x2 = B(i,3);
            y2 = B(i,4);
            w = B(i,5);
            kb = B(i,6);
            hb = B(i,7);
            l = sqrt((x2-x1)^2 + (y2-y1)^2); %Length between the two given points
            beta = atan(hb/kb); %Angle of p1 corner point
            alpha = atan(hb/(1-kb)); %Angle of p2 corner point
            r = pi - beta - alpha; %Kink angle
            L = l*(sqrt(hb^2+kb^2)+sqrt(hb^2+(1-kb)^2));
            cons(k)=L-Configuration.MAX_LENGTH;
            cons(k+1)=Configuration.MIN_LENGTH-L;
            % Kink location
            cons(k+2) = Configuration.MIN_KINK - (sqrt(kb^2+hb^2))*l;
            cons(k+3) = Configuration.MIN_KINK - (sqrt((1-kb)^2+hb^2))*l;
            %cons(k+3) = kb*l - l + Configuration.MIN_KINK;
            
            % Max kink height

            cons(k+4)=hb-sqrt(1/4-(kb-1/2)^2);

            
            k = k + 5;
        end
    end
    
    
    if SHOULD_TRANSFORM_VARIABLES == Configuration.VECTOR
       for i=1:numVars
           x1=B(i,1);
           y1=B(i,2);
           vx1=B(i,3);
           vy1=B(i,4);
           vx2=B(i,5);
           vy2=B(i,6);
           w=B(i,7);
           v1=[vx1,vy1];
           v2=[vx2,vy2];
           cross = @(v1,v2) v1(1)*v2(2)-v1(2)*v2(1);
           % Minimum kink
           cons(k)=Configuration.MIN_KINK - norm(v1);
           cons(k+1)=Configuration.MIN_KINK - norm(v2);
           % Building Length
           cons(k+2)=norm(v1)+norm(v2) - Configuration.MAX_LENGTH;
           cons(k+3)=Configuration.MIN_LENGTH - (norm(v1)+norm(v2));
           % Angle
           cons(k+4)=cross(v1/norm(v1),v2/norm(v2));
           cons(k+5)=cross(v2/norm(v2),[v1(2),-v1(1)]/norm(v1));
           k = k + 6;
       end
    end
    if SHOULD_TRANSFORM_VARIABLES == Configuration.UPDOWNVECTOR
       for i=1:numVars
            x1=B(i,1);
            y1=B(i,2);
            vx1=B(i,3);
            vy1=B(i,4);
            vx2=B(i,5);
            vy2=B(i,6);
            w=B(i,7);
            v1=[vx1,vy1];
            v2=[vx2,vy2];
            cross = @(v1,v2) v1(1)*v2(2)-v1(2)*v2(1);           

            % Extra length
            n1 = [-vy1,vx1]/norm(v1);
            n2 = [-vy2,vx2]/norm(v2);
            midK= mean([n1;n2]);
            nK = midK/norm(midK);
            K = w/dot(n2,nK);
            E = dot(v1/norm(v1),K*nK);
            
            % Minimum kink
            cons(k)=Configuration.MIN_KINK - (norm(v1)-min(E,0));
            cons(k+1)=Configuration.MIN_KINK - (norm(v2)-min(E,0));
            
            % Building Length
            cons(k+2)=norm(v1)+norm(v2) - 2*min(E,0) - Configuration.MAX_LENGTH;
            cons(k+3)=Configuration.MIN_LENGTH - (norm(v1)+norm(v2) - 2*min(E,0));
            % Angle
            cons(k+4)=cross([-v1(2),v1(1)]/norm(v1),v2/norm(v2));
            cons(k+5)=cross(v2/norm(v2),[v1(2),-v1(1)]/norm(v1));
            k = k + 6;
       end
    end
    
    if SHOULD_TRANSFORM_VARIABLES == Configuration.MIDVECTOR
       for i=1:numVars
            x1=B(i,1);
            y1=B(i,2);
            vx1=B(i,3);
            vy1=B(i,4);
            vx2=B(i,5);
            vy2=B(i,6);
            w=B(i,7);
            v1=[vx1,vy1];
            v2=[vx2,vy2];
            cross = @(v1,v2) v1(1)*v2(2)-v1(2)*v2(1);
            L1 = norm(v1);
            L2 = norm(v2);
            
            % Extra length
            %n1 = [-vy1,vx1]/norm(v1);
            %n2 = [-vy2,vx2]/norm(v2);
            %midK= mean([n1;n2]);
            %nK = midK/norm(midK);
            %K = (w/2)/dot(n2,nK);
            %E = dot(v1/norm(v1),K*nK);
            %extraLength = abs(E);
            
            %r = atan2(norm(cross((-v1),v2)),sqrt(sum((-v1).^2)*sum(v2.^2)));
            %r = acos(dot(-v1,v2)/sqrt(sum((-v1).^2)*sum(v2.^2)));
            r = atan2(-v1(1), -v1(2)) - atan2(v2(1), v2(2));
            extraLength = (w/2)/tan(r/2);
            
            % Minimum kink
            cons(k)=Configuration.MIN_KINK - (L1-extraLength);
            cons(k+1)=Configuration.MIN_KINK - (L2-extraLength);
            
            % Building Length
            cons(k+2)=L1+L2 - 2*extraLength - Configuration.MAX_LENGTH;
            cons(k+3)=Configuration.MIN_LENGTH - (L1+L2 - 2*extraLength);
            % Angle
            cons(k+4)=cross([-v1(2),v1(1)]/L1,v2/L2);
            cons(k+5)=cross(v2/L2,[v1(2),-v1(1)]/L1);
            k = k + 6;
       end
    end
    
    
    if SHOULD_TRANSFORM_VARIABLES == Configuration.CENTER
        % Constraint for minimum and maximum kink location
        for i=1:numVars
            kinkLocation = B(i,6);
            len = B(i,4);
            cons(k) = Configuration.MIN_KINK - kinkLocation;
            cons(k+1) = kinkLocation - len + Configuration.MIN_KINK;
            k = k + 2;
        end
    end
    c = cons;
    ceq = [];
end

function corners=variablesToCorners(B, TRANSFORM)
    numVars = size(B, 1);
    C=zeros(6*numVars, 2);
    for i=1:numVars
        bVar = B(i,:);
        bCorners = altCornerPoints(bVar, TRANSFORM);
        n1 = 6*(i-1) + 1;
        n2 = 6*(i-1) + 6;
        C(n1:n2,:) = bCorners;
    end
    corners=C;
end