function d= convexObjectsDistance(obj1,obj2)
%Returns distance measure between two convex shapes
% d > 0 if no overlap
% d = 0 if in contact
% d < 0 if overlap
    %d=smoothObjectsDistance(obj1,obj2);
    %return;
    obj1axes = getObjectAxes(obj1);
    obj2axes = getObjectAxes(obj2);
    n1 = size(obj1,1);
    n2 = size(obj2,1);
    axes = [obj1axes; obj2axes];
    numAxes = size(axes,1);
    axisDistances = zeros(1,numAxes);
    for i=1:numAxes
        obj1scalars = zeros(n1,1);
        obj2scalars = zeros(n2,1);
        axis=axes(i,:);
        for j=1:max(n1,n2)
            if j<=n1
                p1 = obj1(j,:);
                obj1scalars(j) = dot(axis, p1);
            end
            if j<=n2
                p2 = obj2(j,:);
                obj2scalars(j) = dot(axis, p2);
            end
        end
        smallest1 = min(obj1scalars);
        smallest2 = min(obj2scalars);
        largest1 = max(obj1scalars);
        largest2 = max(obj2scalars);
        if (largest2 >= largest1)
            d = smallest2 - largest1;
        else
            d = smallest1 - largest2;
        end
        axisDistances(i)=d; 
    end
    d=max(axisDistances);
end

function axes=getObjectAxes(obj)
    numAxes=size(obj,1);
    axes=zeros(numAxes,2);
    for i=1:numAxes
        j = mod(i,numAxes)+1;
        axes(i,:) = (obj(j,:)-obj(i,:))/norm(obj(j,:)-obj(i,:));
    end
    normals = [-axes(:,2), axes(:,1)];
    axes=normals;
end

