function [Ab]=createLinearInequalities(coordinates)
    numSiteCorners = size(coordinates, 1);
    Ab=zeros(numSiteCorners, 3);
    for i=1:numSiteCorners
        j =  mod(i, numSiteCorners) + 1;
        s = getInequalitySign(coordinates(i,:), coordinates(j,:));
        if coordinates(j,1) == coordinates(i,1)
            Ab(i,1:2) = [s, 0];
            Ab(i,3) = s*coordinates(j,1);
        else
            d = (coordinates(j,2) - coordinates(i,2)) / (coordinates(j,1) - coordinates(i,1));
            incpt = coordinates(j,2) - d*coordinates(j,1);
            Ab(i,1:2) = [-s*d, s];
            Ab(i,3) = s*incpt;
        end
    end
end

function s=getInequalitySign(from, to)
    if to(1) > from(1)
        s = 1;
    elseif to(1) < from(1)
        s = -1;
    elseif to(1) == from(1) && to(2) < from(2)
        s = 1;
    elseif to(1) == from(1) && to(2) > from(2)
        s = -1;
    else
        error('Site line segment is a point, cannot create inequality');               
    end

end