function shapes= getLongOpenZones(cp)
% Returns open zones shapes on long sides
% Rectangles normally out on the facades
    shapes=[
        longOpenZone(cp(2,:),cp(1,:));
        longOpenZone(cp(3,:),cp(2,:));
        longOpenZone(cp(5,:),cp(4,:));
        longOpenZone(cp(6,:),cp(5,:));
    ];
end


function cornerPoints=longOpenZone(p1,p2)
    % - Finds facade open zone
    % - NOTE: p1 and p2 must be ordered so that the angled side starts
    % at p2
    % - Positive angle means longer outer side, negative means smaller
    vec = p2-p1;
    leftVec = Configuration.LENGTH_OPEN_ZONE*[-vec(2),vec(1)]/norm(vec);
    cornerPoints = [p1; p2; p2 + leftVec; p1 + leftVec];
end