function [tr1,tr2]=getTriangleZones(oz,k1,k2)
    % Create triangle open zones around angle points
    % From first kink point ("below")
    
    v1l=findPoint(oz,2,3)-k1;
    v1r=findPoint(oz,1,4)-k1;
    % Check if building kinks inwards at k1
    if cross(v1r,v1l) > 0
        tr1=[
            k1;
            findPoint(oz,1,4);
            findPoint(oz,2,3)
        ];
    elseif cross(v1r,v1l) < 0
        tr1=[
            k1;
            findPoint(oz,2,3);
            findPoint(oz,1,4)
        ];
    else
        tr1=[];
    end
   
    v2l=findPoint(oz,4,3)-k2;
    v2r=findPoint(oz,3,4)-k2;
    if cross(v2r,v2l) > 0
        tr2=[
            k2;
            findPoint(oz,3,4);
            findPoint(oz,4,3);
        ];    
    elseif cross(v2r,v2l) < 0
        tr2=[
            k2;
            findPoint(oz,4,3);
            findPoint(oz,3,4);
            
        ];
    else
        tr2=[];
    end
end


function p=findPoint(openZones,shapeIndex,pointIndex)
    % Find point with index on shape number
    C=4;
    fr=C*(shapeIndex-1)+1;
    to=C*shapeIndex;
    zone=openZones(fr:to,:);
    p=zone(pointIndex,:);
end

function c=cross(v1,v2)
    c=v1(1)*v2(2)-v1(2)*v2(1);
end