function cornerPoints = kinkedCornerPoints(b, varargin)
    x = b(1);
    y = b(2);
    w = b(3);
    l = b(4);
    theta = b(5); 
    k = b(6); 
    r = b(7);

    
    % If bufferzone is added
    extraWidth = 0;
    extraLength = 0;
    extraKink = 0;
    if length(varargin) == 2
        if varargin{1} == true
            extraLength = 2*Configuration.WIDTH_OPEN_ZONE*(1-1/tan(r/2));
            extraWidth = 2*Configuration.WIDTH_OPEN_ZONE;
            extraKink = Configuration.WIDTH_OPEN_ZONE*(1-1/tan(r/2));
        end
        if varargin{2} == true
            extraWidth = 2*Configuration.LENGTH_OPEN_ZONE;
            extraLength = -2*Configuration.LENGTH_OPEN_ZONE/tan(r/2);
            extraKink = -Configuration.LENGTH_OPEN_ZONE/tan(r/2);
        end
    end
    L = l + extraLength;
    W = w + extraWidth;
    K = k + extraKink; 
    
    binv =L-K;
    %Rotation matrix
    R = [cos(theta) -sin(theta); sin(theta) cos(theta)];
    
    if length(varargin)==2
        %Corner points without rotation of building
        if varargin{2} == true 
            c_k = [x + K-(L/2), y-w/2-Configuration.LENGTH_OPEN_ZONE/sin(r/2)];
        elseif varargin{1} == true
            c_k = [x + K-(L/2), y-w/2-Configuration.WIDTH_OPEN_ZONE/sin(r/2)];
        else
            c_k = [x + (K-(L/2)), y-(W/2)];
        end
    else
        c_k = [x + (K-(L/2)), y-(W/2)];
    end
    c1 = [c_k(1) - K*sin(r/2), c_k(2)-K*cos(r/2)];    
    c2 = [c_k(1) + (-K*sin(r/2) - W*cos(r/2)), c_k(2) + (-K*cos(r/2) + W*sin(r/2))];
    c3 = [c_k(1), c_k(2) + (W/cos(pi/2-r/2))];
    %c3 = [c_k(1), c_k(2) + (W/sin(r/2))];
    c4 = [c_k(1) + binv*sin(r/2) + W*cos(r/2), c_k(2) + (-binv*cos(r/2) + W*sin(r/2))];
    c5 = [c_k(1) + binv*sin(r/2), c_k(2) - binv*cos(r/2)];
    
    %Corner points with rotation of building
    V = [c1; c_k; c5; c4; c3; c2];
    C = repmat([x,y],6,1);
    cornerPoints = transpose(R*transpose((V-C)))+ C;
end