function cons=lengthOpenZoneOverlap(b1c,b2c)
%Find overlap of building 1 with corners b1c on the length open zones of
% building 2 
% Creates one constraint for each pair of sub-building footprint and open
% zone
    [b1h1, b1h2] = getHalfBuildings(b1c);
    %[b12h2, b2h2] = getBuildingHalfs(b2c);
    %b1oz = getLongOpenZones(b1c);
    b2oz = getLongOpenZones(b2c);
    [b2tri1,b2tri2] = getTriangleZones(b2oz,b2c(2,:),b2c(5,:));
    cons=zeros(12,1);
    k = 1;
    % Building 1 against open zones of building 2
    for b=1:2
        for i=1:4
            if b==1
                cons(k)=convexObjectsDistance(b1h1, b2oz(4*(i-1)+1:4*(i-1)+4,:));
            else
                cons(k)=convexObjectsDistance(b1h2, b2oz(4*(i-1)+1:4*(i-1)+4,:));
            end
            k = k + 1;
        end
    end
    if ~isempty(b2tri1)
        cons(k)=convexObjectsDistance(b1h1, b2tri1);
        cons(k+1)=convexObjectsDistance(b1h2, b2tri1);
    else
        cons(k:k+1)=0;
    end
    k=k+2;
    if ~isempty(b2tri2)
        cons(k)=convexObjectsDistance(b1h1, b2tri2);
        cons(k+1)=convexObjectsDistance(b1h2, b2tri2);
    else
        cons(k:k+1)=0;
    end
    cons = -1*cons;
    
end

