function [mergedZones,mergedZonesHeights,zonesToMergedZones]=mergeZones(ZONES,ZONES_HEIGHTS)
    [~,idz]=sort(ZONES_HEIGHTS);
    % Merge by increasing height
    % Unecessary to merge last
    n=1;
    mergedZones={};
    mergedZonesHeights=[];
    zonesToMergedZones=zeros(length(ZONES_HEIGHTS),1);
    for i=1:length(idz)-1
        % While some new zones has been merged, keep trying to merge more
        mergedZone=ZONES{idz(i)};
        finished=false;
        toCheck=i+1:length(idz);
        while ~finished && ~isempty(toCheck)
            hasMerged=[];
            for k=1:length(toCheck)
                j=toCheck(k);
                zj=idz(j);
                ijPol=mergePolygons(mergedZone,ZONES{zj});
                if ~isempty(ijPol)
                   mergedZone=ijPol;
                   hasMerged=[hasMerged; toCheck(k)];
                end
            end
            if isempty(hasMerged)
                finished=true;
            else
                toCheck=setdiff(toCheck,hasMerged);
            end
        end
        mergedZones{n}=mergedZone;
        mergedZonesHeights(n)=ZONES_HEIGHTS(idz(i));
        zonesToMergedZones(idz(i))=n;
        n=n+1;
    end
    zonesToMergedZones(idz(end))=n;
    mergedZones{n}=ZONES{idz(end)};
    mergedZonesHeights(n)=ZONES_HEIGHTS(idz(end));
end

function pol=mergePolygons(p1,p2)
%Merge polygons into one if they have common vertices
    %shared1=find(ismember(p1,p2));
    %shared2=find(ismember(p2,p1));
    v1=1:length(p1);
    v2=1:length(p2);
    [~,shared1,shared2]=intersect(p1,p2,'rows');
    if length(shared1) < 2 || length(shared2) < 2
        % We only allow at least two shared vertices
       pol=[];
       return
    end
    
    % Need sorted first
    shared1=sort(shared1);
    shared2=sort(shared2);
    
    if shared1(2)-shared1(1) > 1
        % Wraps around
        shared1 = fliplr(shared1');
    end
    if shared2(2)-shared2(1) > 1
        % Wraps around
        shared2 = fliplr(shared2');
    end
    p1vertices=circshift(v1,length(v1)-shared1(1));
    p2vertices=circshift(v2,length(v2)-shared2(1)+1);
    p2vertices=p2vertices(3:end);
    mPoly=[
        p1(p1vertices,:); p2(p2vertices,:)
    ];
    pol=mPoly;
end

