function distance=nonConvexBuildingOverlap(building1Corners,building2Corners)
    [building1Half1, building1Half2]=getHalfBuildings(building1Corners);
    [building2Half1, building2Half2]=getHalfBuildings(building2Corners);

    d1 = buildingHalfsOverlap(building1Half1, building2Half1);
    d2 = buildingHalfsOverlap(building1Half1, building2Half2);
    d3 = buildingHalfsOverlap(building1Half2, building2Half1);
    d4 = buildingHalfsOverlap(building1Half2, building2Half2);
    %d1 = smoothObjectsDistance(building1Half1, building2Half1);
    %d2 = smoothObjectsDistance(building1Half1, building2Half2);
    %d3 = smoothObjectsDistance(building1Half2, building2Half1);
    %d4 = smoothObjectsDistance(building1Half2, building2Half2);
    
    halfDistances = [d1 d2 d3 d4];
    
    %elemPos = halfDistances > 0; % Logical index
    %posD = halfDistances(elemPos);
    %negD = halfDistances(~elemPos);
    %if (not(isempty(posD)))
    %    minDistance=min(posD);
    %else
    %    minDistance=max(negD);
    %end
    %distance=minDistance;
    
    %distance=min(halfDistances);
    
    % NEW, include all distances as constraints
    distance = halfDistances';
end


function distance = buildingHalfsOverlap(building1Half, building2Half)
    buildingHalf1Axes = getHalfBuildingAxes(building1Half);
    buildingHalf2Axes = getHalfBuildingAxes(building2Half);
    axes = [buildingHalf1Axes; buildingHalf2Axes];
    numAxes = size(axes,1);
    axisDistances = zeros(1,numAxes);
    for i=1:numAxes
        scalars = zeros(4,2);
        for j=1:length(building1Half)
            p1 = building1Half(j,:);
            p2 = building2Half(j,:);
            scalars(j,1) = dot(axes(i,:), p1);
            scalars(j,2) = dot(axes(i,:), p2); 
        end
        smallest = min(scalars);
        largest = max(scalars);
        if (largest(2) >= largest(1))
            d = smallest(2) - largest(1);
        else
            d = smallest(1) - largest(2);
        end
        axisDistances(i)=d;
    end 
    %elemPos = axisDistances > 0; % Logical index
    %posD = axisDistances(elemPos);
    %negD = axisDistances(~elemPos);
    %if (not(isempty(posD)))
    %    minDistance=min(posD);
    %else
    %    minDistance=max(negD);
    %end
    distance=max(axisDistances);
end
