function plot3D(x, SITE, zones, zonesHeights)
    TRANSFORM=Configuration.CENTER;
    footPrintCorners = zeros(6*size(x,1), 2);   
    openZonesWidth = zeros(6*size(x,1), 2);
    for i=1:size(x,1)
       from = 6*(i-1) + 1;
       to = 6*i;
       footPrintCorners(from:to,:) = altCornerPoints(x(i,:),TRANSFORM);
       openZonesWidth(from:to,:) = altCornerPoints(x(i,:),TRANSFORM, true, false);
       %openZonesLength(from:to,:) = kinkedAltVariables(x(i,:), false, true);
    end
    numRects = floor(size(footPrintCorners,1)/6);
    Xx= vec2mat([footPrintCorners(:,1);footPrintCorners(:,1)],6);
    Yy= vec2mat([footPrintCorners(:,2);footPrintCorners(:,2)],6);
    X = transpose(Xx);
    Y = transpose(Yy);

    for i=1:numRects
        for l = 2:6
            faceX(:,i*5+l-6) = [X(l-1,i);X(l,i);X(l,i+numRects);X(l-1,i+numRects)];
            faceY(:,i*5+l-6) = [Y(l-1,i);Y(l,i);Y(l,i+numRects);Y(l-1,i+numRects)];
        end
    end
    p = size(faceX,2);
    for j = 1:numRects
        faceX(:,p+j) = [X(1,j);X(6,j);X(6,j+numRects);X(1,j+numRects)];
        faceY(:,p+j) = [Y(1,j);Y(6,j);Y(6,j+numRects);Y(1,j+numRects)];
    end

    for r=1:numRects
        Z(r) = x(r,8);
    end
    
    Zz = [Z;Z;Z;Z;Z;Z];
    hei = 3*[zeros(6,numRects),Zz];
    for i=1:numRects
        for l = 2:6
            faceZ(:,i*5+l-6) = [hei(l-1,i);hei(l,i);hei(l,i+numRects);hei(l-1,i+numRects)];
        end
    end
    
    for j = 1:numRects
        faceZ(:,p+j) = [hei(1,j);hei(6,j);hei(6,j+numRects);hei(1,j+numRects)];
    end
    
    xBottom = X(:,1:numRects);
    yBottom = Y(:,1:numRects);
    xTop = X(:,numRects+1:end);
    yTop = Y(:,numRects+1:end);
    zBottom = hei(:,1:numRects);
    zTop = hei(:,numRects+1:end);
    
    hold on
    fill3(SITE(:,1),SITE(:,2),zeros(size(SITE,1),1),[1,1,1])
    %fill3(X,Y,hei,[0.5529, 0.6118, 0.8667])
    fill3(xBottom,yBottom,zBottom,[0.5529, 0.6118, 0.8667])
    fill3(faceX,faceY,faceZ,[0.5529, 0.6118, 0.8667])
    fill3(xTop,yTop,zTop,[0.5529, 0.6118, 0.8667])
    axis equal
    axis off
    hold off
    %lightangle(-37.5, 30)
    %lightangle(45,30)
    lightangle(45,45)

    view(3)
end