function plotSolution3D(x, SITE, zones, zonesHeights)
    TRANSFORM=Configuration.CENTER;
    footPrintCorners = zeros(6*size(x,1), 2);   
    openZonesWidth = zeros(6*size(x,1), 2);
    for i=1:size(x,1)
       from = 6*(i-1) + 1;
       to = 6*i;
       footPrintCorners(from:to,:) = altCornerPoints(x(i,:),TRANSFORM);
       openZonesWidth(from:to,:) = altCornerPoints(x(i,:),TRANSFORM, true, false);
       %openZonesLength(from:to,:) = kinkedAltVariables(x(i,:), false, true);

    end
    
    
    % Max height colors
    hcolors=[
        204/255, 255/255, 204/255;
        153/255, 255/255, 153/255;
        102/255, 255/255, 102/255;
        51/255, 255/255, 51/255;
        0/255, 255/255, 0/255;
    ];
    [~, hid]=sort(zonesHeights);
    % Plot height zones
    for i=1:length(zones)
        patch('Faces', 1:length(zones{i}), 'Vertices',zones{i},'EdgeColor','none','FaceColor',hcolors(hid(i),:),'FaceAlpha',0.5);
    end
    
    
    %if length(varargin)~=0 && length(varargin)~= 2
    %    error('Wrong number of varargs in plotProblem')
    %end
    
    % Kink point circle radius
    %rad = Configuration.LENGTH_OPEN_ZONE;
    
    % Plot open zones first so they appear below the building footprints
    %openZonesLength = varargin{2};
    numOpenZones = floor(size(openZonesWidth,1)/6);
    for r=1:numOpenZones
        from = 6*(r-1) + 1;
        to = 6*r;
        wR = openZonesWidth(from:to,:);
        % = openZonesLength(from:to,:);
        patch('Faces', 1:length(wR), 'Vertices', wR,'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8], 'FaceAlpha', 0.3);
        rect = footPrintCorners(from:to,:);
        
%        Kink point circle radius
        %rad = Configuration.STORY_HEIGHT*x(r,8)/tan(Configuration.SUN_ANGLE);
        
        % Length open zones for rect
        lengthOpenZones=getLongOpenZones(rect,x(r,8));
        [tri1,tri2]=getTriangleZones(lengthOpenZones,rect(2,:),rect(5,:));
        for l=1:4
            oz=lengthOpenZones(4*(l-1)+1:4*(l-1)+4,:);
            patch('Faces', 1:length(oz), 'Vertices', oz,'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8], 'FaceAlpha', 0.3);
        end
        
        if ~isempty(tri1)
            patch('Faces', 1:length(tri1), 'Vertices', tri1,'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8], 'FaceAlpha', 0.3);
        end
        if ~isempty(tri2)
            patch('Faces', 1:length(tri2), 'Vertices', tri2,'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8], 'FaceAlpha', 0.3);
        end
        % Kink point circles
        %rectangle('Position',[rect(2,1)-rad,rect(2,2)-rad,2*rad,2*rad], 'Curvature', [1,1],'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8 0.3]);
        %rectangle('Position',[rect(5,1)-rad,rect(5,2)-rad,2*rad,2*rad], 'Curvature', [1,1],'EdgeColor','none','FaceColor', [0.8 0.8 0.8 0.3]);
        %patch('Faces', 1:length(wL),'Vertices', wL,'EdgeColor','none', 'FaceColor', [0.8 0.8 0.8], 'FaceAlpha', 0.5);

    end
    
    patch('Faces', 1:length(SITE), 'Vertices',SITE,'EdgeColor','black','FaceColor','none','LineWidth',1);
    colors =  ['r'; 'g'; 'b'; 'y'; 'm'; 'c'; 'r'; 'g'; 'b'; 'y'; 'm'; 'c'; 'r'; 'g'; 'b'; 'y'; 'm'; 'c'; 'r'; 'g'; 'b'; 'y'; 'm'; 'c'];
    

    numRects = floor(size(footPrintCorners,1)/6);
    for r=1:numRects
        from = 6*(r-1) + 1;
        to = 6*r;
        rect = footPrintCorners(from:to,:);
        patch(transpose(rect(:,1)), transpose(rect(:,2)), colors(r));        
        % Add text above to show height
        %xcenter=x(r,1);
        %ycenter=x(r,2);
        ap1=rect(2,:);
        ap2=rect(5,:);
        xcenter=(ap1(1)+ap2(1))/2;
        ycenter=(ap1(2)+ap2(2))/2;
        height=x(r,8);
        text(xcenter,ycenter,num2str(height), 'Color', 'white', 'FontSize', 18, 'FontWeight','bold');
    end
    axis equal;
    alpha(0.3);
end