function results=runTests(B)
    SITE=41;
    outerConfigs={0};
    init=Configuration.INIT_ANGLEDOPENZONES;
    %clear all
    %clc
    %outerConfigs=[
    %    Configuration.CENTER;
    %    Configuration.LINEWIDTH;
    %    Configuration.LOWERLINEWIDTH;
    %    Configuration.VECTOR;
    %    Configuration.MIDVECTOR;
    %];
    SS=SITE;
    if SS==24
        SITE=selectedSite(SS,true);
    else
        SITE=selectedSite(SS,false);
    end
    fixed=true;
    fixedB=B;
    %Configuration.LENGTH_OPEN_ZONE=3*L;
   

    for oc=1:length(outerConfigs)
        startS=0;
        S = 0;
        runsPerSite=30;
        initial=[
            init
            ];
        results = [];
        siteArea = polygonArea(SITE);
        [nMin, nMax] = minMaxNumberOfBuildings(siteArea);
        if SS==142
           nMax=nMax-1; 
        end
        if fixed==true
            nMin=fixedB;
            nMax=fixedB;
        end
        totalRuns=runsPerSite*length(initial)*(nMax-nMin+1);
        cur=1;
        C=outerConfigs{oc};
        for i=1:length(initial)
            I=initial(i);
            for r=1:runsPerSite
                S = r+startS;
                for N=nMin:nMax
                    tic;    
                    [xout, fval, exitflag, iters]=optimize(SITE, N, S, C, I);
                    toc;
                    disp(['---- TESTING PROGRESS:  ',num2str(100*cur/totalRuns),'% ----'])
                    xtrans=xout';
                    xtrans=xtrans(:);
                    xtrans=xtrans';
                    xrow=zeros(1,size(xout,2)*nMax);
                    xrow(1,1:size(xtrans,2))=xtrans;
                    results = [results; C, I, SS, N, S, exitflag, -fval, siteArea, -fval/siteArea, toc,iters,xrow];
                    cur = cur + 1;
                end
            end
        end

        resultsTable=array2table(results);

        cStrArray=string(C);
        cStr=strjoin(cStrArray,'');

        iStrArray=string(initial);
        iStr=strjoin(iStrArray,'');

        dateFormat='ddmmyy';
        dateStr=datestr(now,dateFormat);

        filename=[cStr,'_',iStr,'_',num2str(SS),'_',num2str(startS),'_',num2str(runsPerSite),'_',dateStr,'_b',num2str(fixedB),'_length',num2str(Configuration.LENGTH_OPEN_ZONE),'.xlsx'];
        writetable(resultsTable,char(strjoin(filename,'')));
        disp(['-*-*-*- CONFIG DONE:  ',num2str(C),'-*-*-*-'])
    end
end
