function a = siteOverlapNonConvex(buildingCorners, CONVEX_STATIC_OBJECT)
    [halfBuilding1, halfBuilding2] = getHalfBuildings(buildingCorners);
    d1 = staticObjectBuildingHalfOverlap(halfBuilding1, CONVEX_STATIC_OBJECT);
    d2 = staticObjectBuildingHalfOverlap(halfBuilding2, CONVEX_STATIC_OBJECT);    
    %d1=smoothObjectsDistance(halfBuilding1,CONVEX_STATIC_OBJECT);
    %d2=smoothObjectsDistance(halfBuilding2,CONVEX_STATIC_OBJECT);
    
    %elemPos = halfDistances > 0; % Logical index
    %posD = halfDistances(elemPos);
    %negD = halfDistances(~elemPos);
    %if (not(isempty(posD)))
    %    minDistance=min(posD);
    %else
    %    minDistance=max(negD);
    %end
    %a=minDistance;
   
    %a = min(d1,d2);
    
    % NEW
    a = [d1;d2];
end

function distance = staticObjectBuildingHalfOverlap(halfBuilding, staticObject)
    buildingHalfAxes = getHalfBuildingAxes(halfBuilding);
    staticObjectAxes = getStaticObjectAxes(staticObject);
    axes = [buildingHalfAxes; staticObjectAxes];
    numAxes = size(axes,1);
    axisDistances = zeros(1,numAxes);
    for i=1:numAxes
        halfBuildingScalars = zeros(4,1);
        for j=1:size(halfBuilding,1)
            p1 = halfBuilding(j,:);
            halfBuildingScalars(j) = dot(axes(i,:), p1);
        end
        staticObjectScalars = zeros(size(staticObject,1),1);
        for j=1:size(staticObject,1)
            p2 = staticObject(j,:);
            staticObjectScalars(j) = dot(axes(i,:), p2);
        end
        smallestBuild = min(halfBuildingScalars);
        smallestStatic = min(staticObjectScalars);
        largestBuild = max(halfBuildingScalars);
        largestStatic = max(staticObjectScalars);
        if (largestStatic >= largestBuild)
            d = smallestStatic - largestBuild;
        else
            d = smallestBuild - largestStatic;
        end
        axisDistances(i)=d; 
    end
    %elemPos = axisDistances > 0; % Logical index
    %posD = axisDistances(elemPos);
    %negD = axisDistances(~elemPos);
    %if (not(isempty(posD)))
    %    minDistance=min(posD);
    %else
    %    minDistance=max(negD);
    %end
    %distance=minDistance;
    distance=max(axisDistances);
end

function axes=getStaticObjectAxes(staticObject)
    numAxes=size(staticObject,1);
    axes=zeros(numAxes,2);
    for i=1:numAxes
        j = mod(i,numAxes)+1;
        axes(i,:) = (staticObject(j,:)-staticObject(i,:))/norm(staticObject(j,:)-staticObject(i,:));
    end
    normals = [axes(:,2), -axes(:,1)];
    axes=normals;
end
    