function d=smoothObjectsDistance(obj1,obj2)
% Overlap 1 with 2 
% https://www.doc.ic.ac.uk/~pp500/pubs/minmaxmin.pdf
    obj1axes = getObjectAxes(obj1);
    obj2axes = getObjectAxes(obj2);
    n1 = size(obj1,1);
    n2 = size(obj2,1);
    %axes = [obj1axes; obj2axes];
    %axes = [obj1axes];
    %numAxes = size(axes,1);
    %axisDistances = zeros(1,numAxes);
    epsJ=-1;
    epsI=1;
    finner=0;
    %mx=-Inf;
    for i=1:size(obj1axes,1)
        n1i=obj1axes(i,:);
        c1i=obj1(i,:);
        inner=0;
        %mn=Inf;
        for j=1:n2
            c2j=obj2(j,:);
            f=dot(c1i,n1i)-dot(c2j,n1i);
            inner = inner + exp(epsJ*f);
            %if f < mn
            %   mn = f; 
            %end
        end
        finner = finner + inner^(epsI/epsJ);
        %if mn > mx
        %   mx=mn; 
        %end
    end
    for i=1:size(obj2axes,1)
        n1i=obj2axes(i,:);
        c1i=obj2(i,:);
        %mn=Inf;
        inner=0;
        for j=1:n1
            c2j=obj1(j,:);
            f=dot(c1i,n1i)-dot(c2j,n1i);
            inner = inner + exp(epsJ*f);
            %if f < mn
            %   mn = f; 
            %end
        end
        finner=finner+inner^(epsI/epsJ);
        %if mn > mx
           %mx=mn; 
        %end
    end
    d=(1/epsI)*log(finner);
    %d=mx;
end



function axes=getObjectAxes(obj)
    numAxes=size(obj,1);
    axes=zeros(numAxes,2);
    for i=1:numAxes
        j = mod(i,numAxes)+1;
        axes(i,:) = (obj(j,:)-obj(i,:))/norm(obj(j,:)-obj(i,:));
    end
    normals = [-axes(:,2), axes(:,1)];
    axes=normals;
end