clear all
clc
% Parallel FDs
delete(gcp('nocreate'))
parpool
SS=142;
SITE=selectedSite(SS);
%site15=selectedSite(15);
%site55=selectedSite(55);
%site16=selectedSite(16);

startS=0;
S = 0;
runsPerSite=30  ;
%configs=[
%    Configuration.CENTER;
%    Configuration.LINEWIDTH;
%];
configs=[
    Configuration.MIDVECTOR;
];
initial=[
    Configuration.INIT_RANDOM
    ];
results = [];
siteArea = polygonArea(SITE);
[nMin, nMax] = minMaxNumberOfBuildings(siteArea);

totalRuns=runsPerSite*length(configs)*length(initial)*(nMax-nMin+1);
cur=1;

for i=1:length(initial)
    I=initial(i);
    for c=1:length(configs)
        C=configs(1);
        for r=1:runsPerSite
            S = r+startS;
            for N=nMin:nMax
                tic;    
                [xout, fval, exitflag, history]=optimize(SITE, N, S, C, I);
                toc;
                disp(['---- TESTING PROGRESS:  ',num2str(100*cur/totalRuns),'% ----'])
                results = [results; C, I, SS, N, S, exitflag, -fval, siteArea, -fval/siteArea, toc];
                cur = cur + 1;
            end
        end
    end
end

resultsTable=array2table(results);

cStrArray=string(configs);
cStr=strjoin(cStrArray,'');

iStrArray=string(initial);
iStr=strjoin(iStrArray,'');

dateFormat='ddmmyy';
dateStr=datestr(now,dateFormat);

filename=[cStr,'_',iStr,'_',num2str(SS),'_',num2str(startS),'_',num2str(runsPerSite),'_',dateStr,'.xlsx'];
writetable(resultsTable,char(strjoin(filename,'')));
