function corners=variableToCorners(b, varargin)
    x = b(1);
    y = b(2);
    w = b(3);
    l = b(4);
    r = b(5);
    
    if length(varargin) == 1 || length(varargin) > 2
        error('Wrong number of arguments to variableToCorners')
    end
    
    extraWidth = 0;
    extraLength = 0;
    if length(varargin) == 2
        if varargin{1} == true
            extraLength = 2*Configuration.WIDTH_OPEN_ZONE;
            extraWidth = 2*Configuration.WIDTH_OPEN_ZONE;
        end
        if varargin{2} == true
            extraWidth = 2*Configuration.LENGTH_OPEN_ZONE;
        end
    end
    
    l_cos = 0.5*(l +extraLength)*cos(r);
    w_sin = 0.5*(w + extraWidth)*sin(r);
    l_sin = 0.5*(l + extraLength)*sin(r);
    w_cos = 0.5*(w + extraWidth)*cos(r);
    c1 = [x + l_cos - w_sin, y + l_sin + w_cos];
    c2 = [x + l_cos + w_sin, y + l_sin - w_cos];
    c3 = [x - l_cos + w_sin, y - l_sin - w_cos];
    c4 = [x - l_cos - w_sin, y - l_sin + w_cos];
    
    corners=[c1;c2;c3;c4];
end
