function cornerPoints = vectorCornerPoints(b, varargin)
x = b(1);
y = b(2);
vec1x = b(3);
vec1y = b(4);
vec2x = b(5);
vec2y = b(6);
w = b(7);

p1 = [x, y];
vec1 = [vec1x, vec1y];
vec2 = [vec2x, vec2y];
lengthVec1 = norm(vec1);
lengthVec2 = norm(vec2);

if length(varargin) == 2
    if varargin{1} == true
        normalVec1 = ([vec1(2), -vec1(1)]*Configuration.WIDTH_OPEN_ZONE)/lengthVec1;
        normalVec2 = ([vec2(2), -vec2(1)]*Configuration.WIDTH_OPEN_ZONE)/lengthVec2;
        extraLengthp1 = (-vec1*Configuration.WIDTH_OPEN_ZONE/lengthVec1) + normalVec1;
        extraLengthp2 = vec2*Configuration.WIDTH_OPEN_ZONE/lengthVec2 + normalVec2;
        extraWidth = 2*Configuration.WIDTH_OPEN_ZONE;
        
        c_k = p1 + vec1;
        p2 = c_k + vec2;
        
        P1 = p1 + extraLengthp1;
        P2 = p2 + extraLengthp2;
       
        VEC1 = P1 + vec1*10;
        VEC2 = P2 - vec2*10;
        
        W = w + extraWidth;
        
        c2 = P2 + W*[-vec2(2), vec2(1)]/lengthVec2;
        c4 = P1 + W*[-vec1(2), vec1(1)]/lengthVec1;

        %Find the intersection of the two given vectors
        den = VEC1(1)*VEC2(2)-VEC1(2)*VEC2(1); 
        if den == 0
            c_k = P1 + vec1 + Configuration.WIDTH_OPEN_ZONE*vec1/lengthVec1;
        else
            u=rayIntersection(P1,vec1,P2,-vec2);
            c_k = P1 + u*vec1;
        end
        
        VEC1U = c4 + vec1*10;
        VEC2U = c2 - vec2*10;
        
        den = VEC1U(1)*VEC2U(2)-VEC1U(2)*VEC2U(1); 
        if den == 0
            c3 = c4 + vec1 + Configuration.WIDTH_OPEN_ZONE*vec1/lengthVec1;
        else
            %ua = (VEC2U(1)*(c4(2)-c2(2))-VEC2U(2)*(c4(1)-c2(1)))/den;
            %c3 = [c4(1) + ua*VEC1U(1), c4(2) + ua*VEC1U(2)];
            %c3 = c4 + ua*VEC1U;
            u=rayIntersection(c4,vec1,c2,-vec2);
            c3 = c4 + u*vec1;
        end
        cornerPoints = [P1; c_k; P2; c2; c3; c4];
    end
else
    c_k = p1 + vec1;
    p2 = c_k + vec2;
    c2 = p2 + w*[-vec2(2), vec2(1)]/lengthVec2;
    c4 = p1 + w*[-vec1(2), vec1(1)]/lengthVec1;
    
    den = vec1(1)*vec2(2)-vec1(2)*vec2(1); 
    if den == 0
        c3 = c4 + vec1;
    else
        ua = (vec2(1)*(c4(2)-c2(2))-vec2(2)*(c4(1)-c2(1)))/den;
        c3 = [c4(1) + ua*vec1(1), c4(2) + ua*vec1(2)];
    end
    
    cornerPoints = [p1; c_k; p2; c2; c3; c4];
end


end


function [u,v]=rayIntersection(as,ad,bs,bd)
    % p = as + ad * u
    % p = bs + bd * v
    % u := (as.y*bd.x + bd.y*bs.x - bs.y*bd.x - bd.y*as.x ) / (ad.x*bd.y - ad.y*bd.x)
    u = (as(2)*bd(1) + bd(2)*bs(1) - bs(2)*bd(1) - bd(2)*as(1) ) / (ad(1)*bd(2) - ad(2)*bd(1));
    %v := (as.x + ad.x * u - bs.x) / bd.x
    v = (as(1) + ad(1) * u - bs(1)) / bd(1);

end
